Build file cleanups

Changes to bldpkg:
-> Added additional variables to be more verbose when showing either errors, warnings or info messages
-> Optimized find command options in various places
-> Discarded makepkg function and moved its code inside mkfinalpkg function
-> Discarded removestaticlibs function.
-> Static libraries are now compulsorily discarded unless preservestaticlibs variable is set near the top of the build file
-> Several smaller fixes
This commit is contained in:
PktSurf 2022-09-13 07:47:33 +05:30
parent 4a48417c00
commit 5d96370bf5
4 changed files with 107 additions and 103 deletions

View file

@ -19,7 +19,7 @@ build() {
./configure \
--prefix="" \
--sysconfdir=/etc \
--sysconfdir=/etc
make
make install DESTDIR=$pkg

204
bldpkg
View file

@ -65,13 +65,13 @@ Building package 'alsa-lib' version '1.x'...
Usage:
-d Produce a package with debug symbols preserved, i.e., don't strip
resulting ELF objects. Uses -g3 by default.
resulting ELF objects. Uses -g3 by default
-e Extract the package installer file in the user's PWD if the build
completes successfully.
completes successfully
-f <file> Name of an alternate build file to source build variables. Should
be compatible with standard SMLinux package build file format.
be compatible with standard SMLinux package build file format
-g Generate SHA512 checksums of all tarballs and patches in the current
directory and insert them into the package build file
@ -110,12 +110,15 @@ fi
validatebldfile() {
local buildfile
buildfile=$1
if [[ ! -f $buildfile ]] ; then
echo "[ERROR] No build file to validate from!"
exit 1
fi
# Start a subshell. We don't want the build file variables in the environment just yet.
(
source $buildfile
source "$buildfile"
# If any of the following variables are not set in the build file, abort.
# $download variable is optional but recommended
@ -131,28 +134,28 @@ validatebldfile() {
# Validate $app
if ! echo "$app" | egrep -q '^[a-z0-9-]+$' ; then
echo "[ERROR] Only lower case, numeric characters and dash allowed in the '"'app'"' variable in the build file."
echo "[ERROR] Only lower case, numeric characters and dash allowed in the 'app' variable in the build file."
exit 1
# Validate $version
elif ! echo "$version" | egrep -q '^[a-z0-9.]+$' ; then
echo "[ERROR] Only lower case, numeric characters and a period allowed in the '"'version'"' variable in the build file."
echo "[ERROR] Only lower case, numeric characters and a period allowed in the 'version' variable in the build file."
exit 1
# Validate $homepage
elif ! echo "$homepage" | egrep -q '^http://|^https://|^ftp://' ; then
echo "[ERROR] Invalid URL in the '"'homepage'"' variable in the build file."
echo "[ERROR] Invalid URL in the 'homepage' variable in the build file."
exit 1
# Validate $download, first the URL type
elif [[ -n $download ]]; then
if ! echo "$download" | egrep -q '^http://|^https://|^ftp://' ; then
echo "[ERROR] Invalid URL in the '"'download'"' variable in the build file."
echo "[ERROR] Invalid URL in the 'download' variable in the build file."
exit 1
# Then check for single quotes
elif egrep -q "download='*'" "$buildfile" ; then
echo "[ERROR] Single quotes disallowed in the download variable"
echo "[ERROR] Single quotes disallowed in the 'download' variable in the build file"
exit 1
fi
@ -163,10 +166,11 @@ validatebldfile() {
# Check if build() function exists in the build file
elif ! egrep -q '^build()' $buildfile ; then
echo "[ERROR] build() function does not exist in your build file."
echo "[ERROR] 'build()' function does not exist in your build file."
exit 1
fi
)
# End subshell
}
# Store the source directory path the build was initiated from
@ -179,9 +183,10 @@ buildfile="$(basename $srcdir).SMBuild"
# Find all required files. If either of them don't exist, abort.
rqfiles=( installpkg upgradepkg sha512sum patch find findmnt patch tput bc tar )
# Run a for loop to find the files
for requiredfile in ${rqfiles[@]}; do
if [[ ! -x $(type -p $requiredfile) ]] ; then
echo "[ERROR] Could not find $requiredfile!"
echo "[ERROR] Could not find required program '"$requiredfile!"'"
exit 1
fi
done
@ -209,19 +214,19 @@ done
if [[ $OPTIND = 1 ]] ; then
if [[ ! -f $buildfile ]] ; then
echo "[ERROR] No package build file to source from!"
echo "[ERROR] Was expecting $buildfile to be present inside this directory '"$PWD"'."
echo "[ERROR] Was expecting '"$buildfile"' to be present inside this directory '"$PWD"'."
echo "[ERROR] Try -f <build_file> if your build file has a different name (Not recommended)"
exit 1
else
if ! validatebldfile $buildfile ; then
echo "[ERROR] Build file validation failed!"
echo "[ERROR] '"$buildfile"' Build file validation failed!"
exit 1
else
source "$buildfile"
fi
fi
# If OPTIND is greater than 1, check if a build file matching the parent directory exists, and if it does, source it.
# If OPTIND is greater than 1, perform various checks and actions
elif [[ $OPTIND -gt 1 ]] ; then
# Override cputhreads sourced from bldpkg.conf if customcputhreads is set. Need to append '-j' so that it gets
@ -229,7 +234,7 @@ elif [[ $OPTIND -gt 1 ]] ; then
if [[ -n $customcputhreads ]] ; then
# And validate whether the value is a number
if ! echo "$customcputhreads" | egrep -q '^[0-9]+$' ; then
echo "[ERROR] Invalid CPU job number. Please try again."
echo "[ERROR] Invalid CPU job number '"$customcputhreads"'. Please provide a valid number."
exit 1
fi
@ -240,7 +245,7 @@ elif [[ $OPTIND -gt 1 ]] ; then
# If $origbuildfile is set and is a file, check if $setbuildfile and $origbuildfile are the same
if [[ -n $origbuildfile ]] ; then
if [[ ! -f $origbuildfile ]] ; then
echo "[ERROR] Original build file $origbuildfile does not exist!"
echo "[ERROR] Original build file '"$origbuildfile"' does not exist!"
exit 1
fi
@ -262,7 +267,7 @@ elif [[ $OPTIND -gt 1 ]] ; then
if [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
buildfile="$setbuildfile"
if ! validatebldfile $buildfile ; then
echo "[ERROR] $buildfile validation failed!"
echo "[ERROR] '"$buildfile"' validation failed!"
exit 1
else
source "$buildfile"
@ -270,13 +275,13 @@ elif [[ $OPTIND -gt 1 ]] ; then
# If $setbuildfile is set but a file passed as an argument is not found, give an error
elif [[ -n $setbuildfile ]] && [[ ! -f $setbuildfile ]] ; then
echo "[ERROR] $setbuildfile not found!"
echo "[ERROR] '"$setbuildfile"' not found!"
exit 1
# If the above two conditions don't meet, get the presumed $buildfile value as a file and source it
elif [[ -f "$buildfile" ]] ; then
if ! validatebldfile $buildfile ; then
echo "[ERROR] $buildfile validation failed!"
echo "[ERROR] '"$buildfile"' validation failed!"
exit 1
else
source "$buildfile"
@ -285,7 +290,7 @@ elif [[ $OPTIND -gt 1 ]] ; then
# If even that file is not found, throw an error and exit
else
echo "[ERROR] No package build file to source from!"
echo "[ERROR] Was expecting $buildfile to be present inside this directory '"$PWD"'."
echo "[ERROR] Was expecting '"$buildfile"' to be present inside this directory '"$PWD"'."
echo "[ERROR] Try -f <build_file> if your build file has a different name (Not recommended)"
exit 1
fi
@ -298,14 +303,14 @@ unset OPTIND OPTARG
if [[ $genchecksum = 1 ]] ; then
# File types whose checksums will go into the new build file
echo "[INFO] Discarding any old sha512sums from $buildfile"
echo "[INFO] Discarding any old sha512sums from '"$buildfile"'"
sed -E -i \
-e '/^sha512sums=".*"$/d' \
-e '/^sha512sums="/,/"$/d' \
-e "/^sha512sums='.*'\$/d" \
"$buildfile"
echo "[INFO] Adding new sha512sums in $buildfile"
echo "[INFO] Adding new sha512sums in '"$buildfile"'"
printf 'sha512sums="\n' >> "$buildfile"
files=( *.tar.* *.zip *.t?z *.patch *.diff *.c *.h )
@ -324,19 +329,19 @@ if [[ $genchecksum = 1 ]] ; then
echo "[WARNING] SHA512 checksums not generated for files inside directories!"
fi
echo "[INFO] You may now run bldpkg again"
echo "[INFO] You may now run 'bldpkg' again"
exit 0
fi
# Display the package and its version we are building
echo "[INFO] Building package $app version $version ..."
echo "[INFO] Building package '"$app"' version '"$version"' ..."
sleep 0.5
# Invoke auditd if useauditd is set to 1 in bldpkg.conf
if [[ $useauditd = 1 ]] ; then
if [[ ! -x /bin/auditd ]] ; then
echo "[ERROR] Auditd not found!"
echo "[ERROR] Program 'auditd' not found!"
exit 1
fi
@ -351,7 +356,7 @@ if [[ $useauditd = 1 ]] ; then
auditpid=$!
# Note: auditd writes about 6-8 lines for our setup when initialized.
echo "[INFO] Auditd initialised."
echo "[INFO] /bin/auditd initialised."
fi
# Function to safely terminate auditd.
@ -359,12 +364,12 @@ terminateauditd() {
if [[ $useauditd = 1 ]] ; then
# Terminate auditd, log number of lines inside a variable
/bin/kill "$auditpid"
echo "[INFO] Auditd stopped."
echo "[INFO] /bin/auditd stopped."
auditlogtermsize="$(wc -l < $auditlogfile)"
if [[ $auditlogtermsize -gt 10 ]] ; then
echo "[WARNING] Auditd log file is greater than 10 lines!"
echo "[WARNING] Auditd log file '"$auditlogfile"' is greater than 10 lines!"
echo "[WARNING] Highly recommend that you examine its file!"
sleep 5
fi
@ -373,7 +378,7 @@ terminateauditd() {
# sha512sums variable is expected in every single package build file
if [[ -z $sha512sums ]] ; then
echo "[ERROR] SHA512 checksums don't exist in $buildfile !"
echo "[ERROR] SHA512 checksums don't exist in '"$buildfile"' !"
echo "[ERROR] Please run 'bldpkg -g' to add them"
exit 1
fi
@ -404,16 +409,16 @@ applypatch() {
echo "[ERROR] Please provide valid patch file name"
exit 1
elif [[ ! -f $patchfile ]] ; then
echo "[ERROR] Patch file not found!"
echo "[ERROR] Patch file '"$patchfile"' not found inside $srcdir!"
exit 1
fi
# Get relative path of the patch file
relativepath="$(basename $patchfile)"
echo "[INFO] Applying patch $relativepath.."
echo "[INFO] Applying patch '"$relativepath"'.."
# We use if/else to determine if the patch applied successfully
if ! patch -p1 < "$patchfile" ; then
echo "[ERROR] Patch file $patchfile failed to apply!"
echo "[ERROR] Failed to aply patch file '"$patchfile"'"
fi
}
@ -422,17 +427,17 @@ if [[ $checkdependencies = 1 ]] ; then
echo "[INFO] Parsing $app 's dependency list..."
for packagedep in "$requires"; do
depcount="$(find /share/doc -name $packagedep.SMBuild | wc -l)"
depcount="$(find /share/doc -type f -name $packagedep.SMBuild | wc -l)"
# If count is 1, we are ok
if [[ $depcount = 1 ]] ; then
echo "[INFO] Found dependency $packagedep"
echo "[INFO] Found dependency '"$packagedep"'"
# If count is 0, we exit, because we are in trouble
elif [[ $depcount = 0 ]] ; then
echo "[ERROR] Did not find dependency $packagedep ."
echo "[ERROR] Did not find dependency '"$packagedep"'."
exit 1
# If count is greater than or equal to 2, we are in slightly less trouble
elif [[ $depcount -ge 2 ]] ; then
echo "[WARNING] Found multiple versions of $packagedep !"
echo "[WARNING] Found multiple versions of '"$packagedep"' !"
sleep 0.5
fi
done
@ -444,10 +449,9 @@ fi
inarray() {
local n=$1 h
shift
for h ;
do
[[ $n = "$h" ]] && return
done
for h ; do
[[ $n = "$h" ]] && return
done
return 1
}
@ -456,14 +460,14 @@ if [[ -z $parenttmp ]] ; then
echo "[ERROR] parenttmp variable not set in /etc/bldpkg.conf."
exit 1
elif [[ ! -d $parenttmp ]] ; then
echo "[ERROR] parenttmp variable set to '"$tmpfsdir"' in /etc/bldpkg.conf is not a directory."
echo "[ERROR] parenttmp variable set to '"$parenttmp"' in /etc/bldpkg.conf is not a directory."
exit 1
fi
# Attempt to write to the $parenttmp directory. This directory is used for everything related to the
# build process outside the source directory $srcdir
if ! touch "$parenttmp"/.smlinuxwritetest ; then
echo "[ERROR] $parenttmp is not writable!"
echo "[ERROR] Parent temp directory '"$parenttmp"' is not writable!"
exit 1
fi
@ -498,7 +502,7 @@ fi
# Validate compressor and set extension
validpkgextensions=( tgz tbz tlz txz )
if ! inarray "${pkgext}" "${validpkgextensions[@]}" ; then
echo "[ERROR] $pkgext is not a valid package extension for an SMLinux installer file."
echo "[ERROR] '"$pkgext"' is not a valid package extension for an SMLinux installer file."
exit 1
fi
@ -539,13 +543,14 @@ if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]]; then
|| [[ "$(findmnt -no FSTYPE $tmpfsdir)" != "tmpfs" ]]; then
tmpfscheckfailed=1
fi
# Discard the file used to test the tmp directory
[[ -e "$tmpfsdir/.smlinuxtmpwritetest" ]] && rm -f "$tmpfsdir/.smlinuxtmpwritetest"
# Check the tmpfsdir for stale directories other than the current package about to be built. If found, issue a warning.
if [[ "$(find $tmpfsdir -type d -maxdepth 1 -print0 | wc -l)" -gt 1 ]]; then
if [[ ! -d $app.src ]] || [[ ! -d package-$app ]] ; then
echo "[WARNING] TMPFS directory has stale directories from previous builds!"
echo "[WARNING] TMPFS directory '"$tmpfsdir"' has stale directories from previous builds!"
sleep 5
fi
fi
@ -636,10 +641,10 @@ if [[ $globaldistcc = 1 ]] ; then
# Check if the symlinks are right
elif [[ ! "$(echo "$PATH" | grep "$distccsympath")" ]] ; then
echo "[ERROR] $distccsympath not found in "'$PATH'"! Fix it please."
echo "[ERROR] '"$distccsympath"' not found in "'$PATH'"! Fix it please."
exit 1
elif [[ ! -d $distccsympath ]] ; then
echo "[ERROR] $distccsympath directory containing symlinks to distcc"
echo "[ERROR] '"$distccsympath"' directory containing symlinks to distcc"
echo "[ERROR] does not exist! Kindly create it and create symlinks"
echo "[ERROR] based on instructions in bldpkg.conf!"
exit 1
@ -650,13 +655,13 @@ if [[ $globaldistcc = 1 ]] ; then
if [[ -e $distccsympath/$f ]] && [[ -L $distccsympath/$f ]]; then
# We use "realpath" to follow the $distccsympath/$f symlink and act on the exit code.
if [[ "$(realpath -e $distccsympath/$f)" != $distccbinpath ]] ; then
echo "[ERROR] $distccsympath/$f does not point to $distccbinpath. "
echo "[ERROR] $distccsympath/$f does not point to '"$distccbinpath"'. "
echo "[ERROR] Kindly fix this!"
exit 1
fi
else
echo "[ERROR] $f either does not exist or is not a symlink inside"
echo "[ERROR] $distccsympath. Kindly fix this! "
echo "[ERROR] '"$distccsympath"'. Kindly fix this! "
exit 1
fi
@ -727,10 +732,10 @@ if [[ $globalccache = 1 ]]; then
fi
if [[ ! "$(echo $PATH | grep $ccachesympath)" ]] ; then
echo "[ERROR] $ccachesympath not found in "'$PATH!'" Fix it please."
echo "[ERROR] '"$ccachesympath"' not found in "'$PATH!'" Fix it please."
exit 1
elif [[ ! -d $ccachesympath ]] ; then
echo "[ERROR] $ccachesympath directory containing symlinks to ccache"
echo "[ERROR] '"$ccachesympath"' directory containing symlinks to ccache"
echo "[ERROR] does not exist! Kindly create it and create symlinks"
echo "[ERROR] based on instructions in bldpkg.conf."
exit 1
@ -740,12 +745,12 @@ if [[ $globalccache = 1 ]]; then
if [[ -e $ccachesympath/$f ]] && [[ -L $ccachesympath/$f ]]; then
# We use "realpath" to follow the $ccachesympath/$f symlink and act on the exit code
if [[ "$(realpath -e $ccachesympath/$f)" != $ccachebinpath ]] ; then
echo "[ERROR] $ccachesympath/$f does not point to $ccachebinpath. "
echo "[ERROR] '"$ccachesympath/$f"' does not point to '"$ccachebinpath"'. "
echo "[ERROR] Kindly fix this!"
exit 1
fi
else
echo "[ERROR] $f either does not exist or is not a symlink inside $ccachesympath"
echo "[ERROR] $f either does not exist or is not a symlink inside '"$ccachesympath"'"
echo "[ERROR] Kindly fix this!"
exit 1
fi
@ -797,10 +802,10 @@ if [[ $globalsccache = 1 ]]; then
fi
if [[ ! "$(echo $PATH | grep $sccachepath)" ]] ; then
echo "[ERROR] $sccachepath not found in "'$PATH!'" Fix it please."
echo "[ERROR] '"$sccachepath"' not found in "'$PATH!'" Fix it please."
exit 1
elif [[ ! -d $sccachepath ]] ; then
echo "[ERROR] $sccachepath directory containing symlinks to ccache"
echo "[ERROR] '"$sccachepath"' directory containing symlinks to ccache"
echo "[ERROR] does not exist! Kindly create it and create symlinks"
echo "[ERROR] based on instructions in bldpkg.conf."
exit 1
@ -815,12 +820,12 @@ if [[ $globalsccache = 1 ]]; then
sccache_hardlink_file_inode_num="$(stat --printf '%i\n' $sccachepath/$f)"
if [[ ! -e $sccachepath/$f ]] ; then
echo "[ERROR] $f either does not exist inside $sccachepath"
echo "[ERROR] $f either does not exist inside '"$sccachepath"'"
echo "[ERROR] Kindly fix this!"
exit 1
# If the hard link's inode number does not match the original binary's inode number, throw an error and exit
elif [[ $sccache_hardlink_file_inode_num != $sccache_binary_inode_num ]] ; then
echo "[ERROR] File '"$f"' inside $sccachepath is not a hard link!"
echo "[ERROR] File '"$f"' inside '"$sccachepath"' is not a hard link!"
echo "[ERROR] Kindly fix this!"
exit 1
fi
@ -968,32 +973,6 @@ fixbuilddirpermissions() {
echo " done."
}
# https://gist.github.com/ruario/9672717
# Custom function from the above author for creating a slackware package. Entirely removes the need to use slackware's makepkg.
makepkg() {
echo "[INFO] Generating SMLinux package..."
# If $disablepkgsymlinks is not set in the package build file, change any symlinks into shell script code
if [[ -z $disablepkgsymlinks ]] ; then
if find * -type l | grep -qm1 .; then
echo "[INFO] Found symlinks, preparing install/doinst.sh..."
find * -type l -printf '( cd %h ; rm -rf %f )\n( cd %h ; ln -sf %l %f )\n' -delete > install/symlinks
if [[ -f install/doinst.sh ]]; then
printf '\n' | cat - install/doinst.sh >> install/symlinks
fi
mv install/symlinks install/doinst.sh
fi
fi
tar cvf - . --format gnu \
--xform 'sx^\./\(.\)x\1x' \
--show-stored-names | $compressor $compressoropts > "$newpkglocation"
echo ""
echo "[INFO] SMLinux package '"$app-$version-$arch-$build.$pkgext"' successfully generated in $pkgdest."
}
# Function to calculate elapsed build time. runtime takes the $SECONDS variable as an argument. $SECONDS is an
# environment variable set by bash to show the number of whole seconds the shell has been running.
runtime() {
@ -1057,13 +1036,6 @@ preprunitservice() {
chmod 0755 "$pkg/etc/service/$1/run"
}
# Function to remove static libraries for use inside build scripts
# To be invoked inside a package build file.
removestaticlibs() {
echo "[INFO] Discarding static libraries..."
find "$pkg" -name "*.a" -exec rm -fv {} \;
}
# Function to perform post-compile tasks.
# To be invoked inside a package build file.
mkfinalpkg() {
@ -1094,8 +1066,8 @@ mkfinalpkg() {
# Check if /usr and /sbin were created inside $pkg
for directory in usr sbin ; do
if [[ -d $pkg/$directory ]] ; then
echo "[ERROR] $app has $directory directory which is a symlink to /bin on SMLinux."
echo "[ERROR] Please fix the build options and ensure $directory is not created."
echo "[ERROR] $app has '"$directory"' directory which is a symlink to /bin on SMLinux."
echo "[ERROR] Please fix the build options and ensure '"$directory"' is not created."
exit 1
fi
done
@ -1135,7 +1107,7 @@ EOF
# Remove .la files similar to what slackware devs are doing in slackware-current, but in a more efficient manner :)
echo "[INFO] Discarding any libtool archive (.la) files..."
find "$pkg" -type f -name "*.la" -delete
find "$pkg" -type f -name "*.la" -exec rm -v {} \;
# Provide a copy of the package build file so that users know the build options that went into compiling the package
if [[ -n $origbuildfile ]] && [[ -f $srcdir/$origbuildfile ]] ; then
@ -1154,11 +1126,19 @@ EOF
rmdir "$pkg/share/doc/$app"
fi
# We'd like pkgconfig files to only go into /lib; some packages have other ideas. So fix for them
if [[ -d $pkg/share/pkgconfig ]] ; then
echo "[WARNING] $app has created share/pkgconfig directory."
echo "[WARNING] Moving this directory into /lib"
mkdir -p "$pkg/lib"
mv "$pkg/share/pkgconfig" "$pkg/lib/"
fi
# Normally we'd expect some debug symbols in the newly-produced binaries. But that isn't always the
# case with some packages whose build systems strip objects before hand
if [[ $debug = 1 ]] ; then
for file in \
$( find "$pkg" )
$( find "$pkg" -type f )
do
file -m /etc/file/magic/elf $file | \
grep -E "executable|shared object" | \
@ -1175,15 +1155,18 @@ EOF
# Now strip the binaries and shared libraries. --strip-unneeded is unnecessary for binutils 2.34+
if [[ -z $debug ]] && [[ $debug != 1 ]]; then
find "$pkg" -print0 | xargs -0 file -m /etc/file/magic/elf | \
grep -E "executable|shared object|statically linked" | grep "ELF" | \
find "$pkg" -type f -print0 | xargs -0 file -m /etc/file/magic/elf | \
grep -E "ELF.*(executable|shared object|statically linked)" |\
cut -d: -f1 | xargs strip 2>/dev/null || true
fi
# And static libraries separately unconditionally
find "$pkg" -print0 | xargs -0 file -m /etc/file/magic/archive | \
# If $preservestaticlibs is not set in the package build file, delete all static libraries
if [[ -z $preservestaticlibs ]] ; then
echo "[INFO] Discarding any static libraries..."
find "$pkg" -type f -print0 | xargs -0 file -m /etc/file/magic/archive | \
grep -E "current ar archive" | awk '{print $1}' | cut -d: -f1 | \
xargs strip 2>/dev/null || true
xargs rm -v 2>/dev/null || true
fi
# Calculate total files, directories, symlinks and uncompressed staging directory size
if [[ $showsummary = 1 ]] ; then
@ -1200,10 +1183,31 @@ EOF
# Store package location inside this variable:
newpkglocation="$pkgdest/$app-$version-$arch-$build.$pkgext"
# Finally create the package
makepkg "$newpkglocation"
# https://gist.github.com/ruario/9672717
# Create the SMLinux package
echo "[INFO] Generating SMLinux package..."
# If $disablepkgsymlinks is not set in the package build file, change any symlinks into shell script code. An example is base/initfs wherein
# we only want the doinst.sh file in the source directory to be copied, not manipulated.
if [[ -z $disablepkgsymlinks ]] ; then
if find . -type l | grep -qm1 .; then
echo "[INFO] Found symlinks, preparing install/doinst.sh..."
find . -type l -printf '( cd %h ; rm -rf %f )\n( cd %h ; ln -sf %l %f )\n' -delete > install/symlinks
if [[ -f install/doinst.sh ]]; then
printf '\n' | cat - install/doinst.sh >> install/symlinks
fi
mv install/symlinks install/doinst.sh
fi
fi
tar cvf - . --format gnu \
--xform 'sx^\./\(.\)x\1x' \
--show-stored-names | $compressor $compressoropts > "$newpkglocation"
pkgstatus=$?
echo ""
echo "[INFO] SMLinux package '"$app-$version-$arch-$build.$pkgext"' successfully generated in $pkgdest."
# Terminate auditd daemon
terminateauditd

View file

@ -17,7 +17,7 @@ build() {
./configure \
--prefix="" \
--sysconfdir=/etc
--sysconfdir=/etc
make
make install DESTDIR=$pkg

View file

@ -3,7 +3,7 @@ version=2020.1
build=1sml
homepage="https://xorg.freedesktop.org/"
download="https://xorg.freedesktop.org/archive/individual/proto/xorgproto-$version.tar.bz2"
desc="combined X.Org X11 Protocol headers"
desc="Combined X.Org X11 Protocol headers"
requires="musl"
build() {